<?

/* Action permettant de crer un blog
 *
 * Chaque billet d'un blog est en fait une page Wiki, dont le nom est
 * de la forme Blog-DATE-SECTION. La DATE est de la forme
 * YYYYMMDDHHMMSS. Par exemple : Blog-20040502115413-Technologie.
 *
 * Cette fonction affiche les diffrents billets d'un blog. Si aucun
 * argument n'est fourni, alors les 10 derniers billets sont
 * affiches. On peut galement donner une spcification de date
 * "datespec" pour restreindre l'affichage des billets  un mois, un
 * jour, une anne, ou bien spcifier la section du billet.
 *
 * IMPORTANT : dans tous les cas, cette page affiche uniquement les 10
 * derniers billets. Il faudrait peut tre afficher tous les billets
 * si une section est demande par exemple.
 *
 * Dvelopp par Thomas Petazzoni, thomas.petazzoni@enix.org
 */

/* Fonction de conversion d'une date. Il y a peut tre moyen de faire
   plus propre, mais je ne suis pas un spcialiste de la bibliothque
   de fonctions PHP */
function BlogConvertDate($date)
{
  $minute = substr($date, 10, 2);
  $hour   = substr($date, 8, 2);
  $day = substr($date, 6, 2);
  $month = substr($date, 4, 2);
  $year = substr($date, 0, 4);

  if($hour != "")
    {
      return $day . "/" . $month . "/" . $year . " - " . $hour . ":" . $minute;
    }
  else
    {
      return $day . "/" . $month . "/" . $year;
    }
}

/* On commence par construire ce que doit matcher le nom de la page
   correspond au billet, en fonction de la spcification de date et de
   section. */
if($_GET["datespec"])
{
  $match = "Blog-" . $_GET["datespec"] . "%";
}
else
{
  $match = "Blog-%";
}

if($_GET["section"])
{
  $match = $match . "-" . $_GET["section"];
}

/* On va ensuite charger toutes les pages Wiki qui correspondent  la recherche */
$pages = $this->LoadAll("select tag, owner, body from " . 
			$this->config["table_prefix"]."pages where latest = 'Y' and tag like '$match' order by tag desc limit 10");

if (is_array($pages)) {

  /* Puis on les affiche */
  foreach ($pages as $page)
    {

      /* Si le visiteur n'a pas le droit de lecture sur le billet, on
         ne l'affiche pas. Cela permet par exemple de prparer des
         billets, de les relire avant de les publier sur le site en
         activant le droit de lecture pour tous. */

      if(! $this->hasAccess("read", $page["tag"]))
	{
	  continue;
	}

      /* On commence le billet */
      echo "<div class=\"blog\">\n";
      $vals = split('-', $page["tag"]);

      /* On compte le nombre de commentaire */
      $comment_count = count($this->LoadComments($page["tag"]));

      /* Le titre du billet */
      echo "<h1 class=\"title\"><a href=\"wakka.php?wiki=BlogPage&datespec=" . substr($vals[1], 0, 8) . "\">" . 
	BlogConvertDate($vals[1]) . "</a> - <a href=\"wakka.php?wiki=BlogPage&section=" . $vals[2] .
	"\">" . $vals[2] . "</a> - <a href=\"wakka.php?wiki=" . $page["tag"] . "&show_comments=1\">";
      
      /* Le lien vers les commentaires */
      if($comment_count == 0)
	{
	  echo "Aucun commentaire";
	}
      else if($comment_count == 1)
	{
	  echo "1 commentaire";
	}
      else
	{
	  echo $comment_count . " commentaires";
	}

      echo "</a>\n";

      /* Est-ce que le visiteur a le droit d'diter le billet ? */
      if($this->hasAccess("write", $page["tag"]))
	{
	  echo " - <a href=\"" . $this->config["base_url"] . $page["tag"] . "/edit\">Editer</a>";
	}
      
      echo "</h1>";

      /* Affichage du corps du billet */
      echo $this->Format($page["body"]);
      echo "</div>";
    }
} 

?>